---
title: WebDriver errors
slug: Web/WebDriver/Errors
tags:
  - Automation
  - Reference
  - Testing
  - Web
  - WebDriver
---
<p>Any WebDriver <a href="/en-US/docs/Web/WebDriver/Commands">command</a> that is sent to might plausibly receive an error <a href="/en-US/docs/Web/WebDriver/Response">response</a>. An error is represented by an <a href="/en-US/docs/Web/HTTP">HTTP response</a> with an <a href="/en-US/docs/Web/HTTP/Status">HTTP status code</a> in the 4xx or 5xx range, and a JSON payload holding details of the error.</p>

<h2 id="Payload">Payload</h2>

<p>The <strong>error object</strong> is a JSON Object that bears three, and sometimes four, fields:</p>

<dl>
 <dt><code>error</code></dt>
 <dd>Error type.</dd>
 <dt><code>message</code></dt>
 <dd>Human-readable description of the nature of the error.</dd>
 <dt><code>stacktrace</code></dt>
 <dd>Stacktrace report of the active stack frames at the time when the error occurred.</dd>
 <dt><code>data</code> (optional)</dt>
 <dd>Arbitrary and implementation-defined data that it can be useful to present the user with.<br>
 <br>
 Many drivers include the <a href="/en-US/docs/Web/API/Window/alert">user prompt</a>’s text when encountering an <a href="/en-US/docs/Web/WebDriver/Errors/UnexpectedAlertOpen">unexpected alert open</a> error.</dd>
</dl>

<h2 id="Example">Example</h2>

<p>For example a <code><a href="/en-US/docs/Web/HTTP/Methods/GET">GET</a></code> request to <code>/session/1234/url</code>, where <code>1234</code> is a bogus session, would return a response with the {{HTTPStatus(404, "404 Not Found")}} status and the following body:</p>

<pre class="brush: json">{
	<span class="hljs-attr">"value"</span>: {
		<span class="hljs-attr">"error"</span>: <span class="hljs-string">"invalid session id"</span>,
		<span class="hljs-attr">"message"</span>: <span class="hljs-string">"No active session with ID 1234"</span>,
		<span class="hljs-attr">"stacktrace"</span>: <span class="hljs-string">""</span>
	}
}</pre>

<p>It is optional for the driver to annotate errors with additional error data. Notably, this is common when a user prompt, such as <code>window.alert</code>, has opened a modal dialog after execution of your previous WebDriver command request.</p>

<p>Because both WebDriver and JavaScript execution is halted by such a dialog, we see an <a href="/en-US/docs/Web/WebDriver/Errors/UnexpectedAlertOpen">unexpected alert open</a> error in the subsequent response:</p>

<pre class="brush: json">{
	<span class="hljs-attr">"value"</span>: {
		<span class="hljs-attr">"error"</span>: <span class="hljs-string">"unexpected alert open"</span>,
		<span class="hljs-attr">"message"</span>: <span class="hljs-string">""</span>,
		<span class="hljs-attr">"stacktrace"</span>: <span class="hljs-string">""</span>,
		<span class="hljs-attr">"data"</span>: {
			<span class="hljs-attr">"text"</span>: <span class="hljs-string">"Message from window.alert"</span>
		}
	}
}</pre>

<p>In most <a href="/en-US/docs/Web/WebDriver/Clients">clients</a> the error would be represented by some sort of error <em>type</em> or <em>object representation</em>. In Python it is represented as a <code><a href="https://seleniumhq.github.io/selenium/docs/api/py/common/selenium.common.exceptions.html">WebDriverException</a></code>, in Node.js as a <code><a href="https://seleniumhq.github.io/selenium/docs/api/javascript/module/selenium-webdriver/lib/error_exports_WebDriverError.html">WebDriverError</a></code>, and in Java also as a <code><a href="https://seleniumhq.github.io/selenium/docs/api/java/org/openqa/selenium/WebDriverException.html">WebDriverException</a></code>.</p>

<h2 id="Table_of_errors">Table of errors</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Error type</th>
   <th scope="col">HTTP status code</th>
   <th scope="col">Description</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><a href="/en-US/docs/Web/WebDriver/Errors/ElementClickIntercepted">element click intercepted</a></td>
   <td>{{HTTPStatus(400, "400 Bad Request")}}</td>
   <td>The <a class="internalDFN" href="/en-US/docs/Web/WebDriver/ElementClick">Element Click</a> <a class="internalDFN" href="/en-US/docs/Web/WebDriver/Command">command</a> could not be completed because the <a class="internalDFN" href="/en-US/docs/Web/WebDriver/WebElement">element</a> receiving the events is obscuring the element that was requested clicked.</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/WebDriver/Errors/ElementNotInteractable">element not interactable</a></td>
   <td>{{HTTPStatus(400, "400 Bad Request")}}</td>
   <td>A <a class="internalDFN" href="/en-US/docs/Web/WebDriver/Command">command</a> could not be completed because the element is not pointer- or keyboard interactable.</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/WebDriver/Errors/InsecureCertificate">insecure certificate</a></td>
   <td>{{HTTPStatus(400, "400 Bad Request")}}</td>
   <td>Navigation caused the user agent to hit a certificate warning, which is usually the result of an expired or invalid TLS certificate.</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/WebDriver/Errors/InvalidArgument">invalid argument</a></td>
   <td>{{HTTPStatus(400, "400 Bad Request")}}</td>
   <td>The arguments passed to a <a class="internalDFN" href="/en-US/docs/Web/WebDriver/Command">command</a> are either invalid or malformed.</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/WebDriver/Errors/InvalidCookieDomain">invalid cookie domain</a></td>
   <td>{{HTTPStatus(400, "400 Bad Request")}}</td>
   <td>An illegal attempt was made to set a cookie under a different domain than the current page.</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/WebDriver/Errors/InvalidElementState">invalid element state</a></td>
   <td>{{HTTPStatus(400, "400 Bad Request")}}</td>
   <td>A <a class="internalDFN" href="/en-US/docs/Web/WebDriver/Command">command</a> could not be completed because the element is in an invalid state, e.g. attempting to <a class="internalDFN" href="/en-US/docs/Web/WebDriver/ElementClear">clear</a> an element that isn't both editable and resettable.</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/WebDriver/Errors/InvalidSelector">invalid selector</a></td>
   <td>{{HTTPStatus(400, "400 Bad Request")}}</td>
   <td>An element retrieval command provided an unknown selector strategy.</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/WebDriver/Errors/InvalidSessionID">invalid session id</a></td>
   <td>{{HTTPStatus(404, "404 Not Found")}}</td>
   <td>Given session ID is not recognised, meaning the session either does not exist of that it’s not active. Note that a session that <a href="/en-US/docs/Web/WebDriver/DeleteSession">has been deleted</a> cannot be re-used.</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/WebDriver/Errors/JavaScriptError">javascript error</a></td>
   <td>{{HTTPStatus(500, "500 Internal Server Error")}}</td>
   <td>An error occurred while executing JavaScript supplied by the user.</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/WebDriver/Errors/MoveTargetOutOfBounds">move target out of bounds</a></td>
   <td>{{HTTPStatus(500, "500 Internal Server Error")}}</td>
   <td>The target for mouse interaction is not in the browser’s viewport and cannot be brought into that viewport.</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/WebDriver/Errors/NoSuchAlert">no such alert</a></td>
   <td>{{HTTPStatus(404, "404 Not Found")}}</td>
   <td>An attempt was made to operate on a user prompt when one was not open.</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/WebDriver/Errors/NoSuchCookie">no such cookie</a></td>
   <td>{{HTTPStatus(404, "404 Not Found")}}</td>
   <td>No cookie matching the given path name was found amongst the <a class="internalDFN" href="/en-US/docs/Glossary/Cookie">cookies</a> of the current <a href="/en-US/docs/Web/API/Document">document</a>.</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/WebDriver/Errors/NoSuchElement">no such element</a></td>
   <td>{{HTTPStatus(404, "404 Not Found")}}</td>
   <td>An element could not be located on the page using the given search parameters.</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/WebDriver/Errors/NoSuchFrame">no such frame</a></td>
   <td>{{HTTPStatus(404, "404 Not Found")}}</td>
   <td>A <a class="internalDFN" href="/en-US/docs/Web/WebDriver/Command">command</a> to switch to a frame could not be satisfied because the frame could not be found.</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/WebDriver/Errors/NoSuchWindow">no such window</a></td>
   <td>{{HTTPStatus(404, "404 Not Found")}}</td>
   <td>A <a class="internalDFN" href="/en-US/docs/Web/WebDriver/Command">command</a> to switch to a window could not be satisfied because the window could not be found.</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/WebDriver/Errors/ScriptTimeout">script timeout</a></td>
   <td>{{HTTPStatus(408, "408 Request Timeout")}}</td>
   <td>A script did not complete before its timeout expired.</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/WebDriver/Errors/SessionNotCreated">session not created</a></td>
   <td>{{HTTPStatus(500, "500 Internal Server Error")}}</td>
   <td>A new session could not be created, either because the browser could not be started or because the provided <a href="/en-US/docs/Web/WebDriver/Capabilities">capabilities</a> to start the session did not match.</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/WebDriver/Errors/StaleElementReference">stale element reference</a></td>
   <td>{{HTTPStatus(404, "404 Not Found")}}</td>
   <td>A <a class="internalDFN" href="/en-US/docs/Web/WebDriver/Command">command</a> failed because the referenced <a class="internalDFN" href="/en-US/docs/Web/WebDriver/WebElement">element</a> is no longer attached to the DOM.</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/WebDriver/Errors/Timeout">timeout</a></td>
   <td>{{HTTPStatus(408, "408 Request Timeout")}}</td>
   <td>An operation did not complete before its timeout expired.</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/WebDriver/Errors/UnableToSetCookie">unable to set cookie</a></td>
   <td>{{HTTPStatus(500, "500 Internal Server Error")}}</td>
   <td>A <a class="internalDFN" href="/en-US/docs/Web/WebDriver/Command">command</a> to set a cookie’s value could not be satisfied.</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/WebDriver/Errors/UnableToCaptureScreen">unable to capture screen</a></td>
   <td>{{HTTPStatus(500, "500 Internal Server Error")}}</td>
   <td>A screen capture was made impossible.</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/WebDriver/Errors/UnexpectedAlertOpen">unexpected alert open</a></td>
   <td>{{HTTPStatus(500, "500 Internal Server Error")}}</td>
   <td>A modal dialog was open, blocking this operation.</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/WebDriver/Errors/UnknownCommand">unknown command</a></td>
   <td>{{HTTPStatus(404, "404 Not Found")}}</td>
   <td>A <a class="internalDFN" href="/en-US/docs/Web/WebDriver/Command">command</a> could not be executed because the driver was unaware of it.</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/WebDriver/Errors/UnknownError">unknown error</a></td>
   <td>{{HTTPStatus(500, "500 Internal Server Error")}}</td>
   <td>An unknown error occurred in the driver whilst processing the <a class="internalDFN" href="/en-US/docs/Web/WebDriver/Command">command</a>.</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/WebDriver/Errors/UnknownMethod">unknown method</a></td>
   <td>{{HTTPStatus(405, "405 Method Not Allowed")}}</td>
   <td>The requested <a class="internalDFN" href="/en-US/docs/Web/WebDriver/Command">command</a> matched a known URL but did not match a method for that URL.</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/WebDriver/Errors/UnsupportedOperation">unsupported operation</a></td>
   <td>{{HTTPStatus(500, "500 Internal Server Error")}}</td>
   <td>Indicates that a <a class="internalDFN" href="/en-US/docs/Web/WebDriver/Command">command</a> that should have executed properly cannot be supported for some reason.</td>
  </tr>
 </tbody>
</table>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/WebDriver/Response">WebDriver responses</a></li>
 <li><a href="/en-US/docs/Web/WebDriver/Commands">WebDriver commands</a></li>
</ul>

<p>{{QuickLinksWithSubpages}}</p>
